/*
 * @file EwECOA_modMain_Im.c
 * Module Interface for Module EwECOA_modMain_Im
 */
/*
 ##############################################################
 # (C) 2016 BAE SYSTEMS
 #
 # EmbedWithECOA - EwECOA Implementation Code
 #
 # $Id: EwECOA_modMain_Im.c,v 2.3 2017/11/06 15:33:43 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes, 
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/

#include "EwECOA_modMain_Im.h"

#define A 1
#define B 2
#define C 3
#define D 4

void EwECOA_modMain_Im__INITIALIZE__received(EwECOA_modMain_Im__context *context)
{
	context->user.curPattern = D;
	context->user.displayCode = 0;
	context->user.seqNo = 0;
}

void EwECOA_modMain_Im__START__received(EwECOA_modMain_Im__context *context)
{
   /* User Code Here */
}

void EwECOA_modMain_Im__STOP__received(EwECOA_modMain_Im__context *context)
{
   /* User Code Here */
}

void EwECOA_modMain_Im__SHUTDOWN__received(EwECOA_modMain_Im__context *context)
{
   /* User Code Here */
}

void EwECOA_modMain_Im__PatternASelected__received(EwECOA_modMain_Im__context *context)
{
	context->user.curPattern = A;
	context->user.displayCode = 0;
	context->user.seqNo = 0;
}

void EwECOA_modMain_Im__PatternBSelected__received(EwECOA_modMain_Im__context *context)
{
	context->user.curPattern = B;
	context->user.displayCode = 0;
	context->user.seqNo = 0;
}

void EwECOA_modMain_Im__PatternCSelected__received(EwECOA_modMain_Im__context *context)
{
	context->user.curPattern = C;
	context->user.displayCode = 0;
	context->user.seqNo = 0;
}

void EwECOA_modMain_Im__PatternDSelected__received(EwECOA_modMain_Im__context *context)
{
	context->user.curPattern = D;
	context->user.displayCode = 0;
	context->user.seqNo = 0;
}

const ECOA__uint8 codes[] = { 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };

void EwECOA_modMain_Im__Tick__received(EwECOA_modMain_Im__context *context)
{
	switch( context->user.curPattern ){
		case A:
			if( context->user.displayCode == 0 ){
				context->user.displayCode = 0x01;
			}else{
				context->user.displayCode = context->user.displayCode << 1;
				if( context->user.displayCode > 0x20 )
					context->user.displayCode = 0x01;
			}
			break;
		case B:
			context->user.displayCode += 1;
			if( context->user.displayCode > 63 )
				context->user.displayCode = 0;
			break;
		case C:
			switch( context->user.displayCode ){
				case 0x00:
					context->user.displayCode = 0x0C;
					break;
				case 0x0C:
					context->user.displayCode = 0x12;
					break;
				case 0x12:
					context->user.displayCode = 0x21;
					break;
				case 0x21:
					context->user.displayCode = 0x00;
					break;
			}
			break;
		case D:
			context->user.displayCode = codes[ context->user.seqNo ];
			context->user.seqNo = (++(context->user.seqNo)) % 12;
			break;
	}
	EwECOA_modMain_Im_container__DisplayCode__send( context, context->user.displayCode );
}
