/*
 * EwECOAIF_Host.c
 *
 *  Created on: 12 Oct 2016
 *      Author: sw_appleby
 */

#include <stdio.h>
#include <pthread.h>
#include <time.h>
#include <types/vxTypesOld.h>
#include <drv/gp2Gpio.c>

#include "../EwECOAIF_External_Interface.h"

struct timespec Zzzz = { 0, 10000000 };

void* buttonPoller( void* p )
{
	BOOL bitValue;
	//
	// Poll the buttons...
	for(;;){
		// bit numbers are TBC
		gpioInGet( 0, &bitValue );
		if( bitValue ){
			EwECOAIF__ButtonA();
		}else{
		gpioInGet( 1, &bitValue );
		if( bitValue ){
			EwECOAIF__ButtonB();
		}else{
		gpioInGet( 2, &bitValue );
		if( bitValue ){
			EwECOAIF__ButtonC();
		}else{
		gpioInGet( 3, &bitValue );
		if( bitValue ){
			EwECOAIF__ButtonD();
		}}}}
		nanosleep( &Zzzz, NULL );
	}
	return NULL;
}

void ioinit()
{
	static pthread_t keythrd;
	//
	gpioPinsConfig( 0xFFFF0000 ); // TBC
	//
	// Spin the button poller
	pthread_create( &keythrd, NULL, buttonPoller, NULL );
}

void putLights( unsigned char displayCode )
{
	// bit numbers are TBC       0/1 may need to be inverted...
	gpioOutSet( 0, (BOOL)( displayCode & 0x01 ? 1 : 0 ));
	gpioOutSet( 1, (BOOL)( displayCode & 0x02 ? 1 : 0 ));
	gpioOutSet( 2, (BOOL)( displayCode & 0x04 ? 1 : 0 ));
	gpioOutSet( 3, (BOOL)( displayCode & 0x08 ? 1 : 0 ));
	gpioOutSet( 4, (BOOL)( displayCode & 0x10 ? 1 : 0 ));
	gpioOutSet( 5, (BOOL)( displayCode & 0x20 ? 1 : 0 ));
}
