/*
 * EwECOAIF_Host.c
 *
 *  Created on: 12 Oct 2016
 *      Author: sw_appleby
 */

#include <stdio.h>
#include <curses.h>
#include <pthread.h>
#include <time.h>

#include "../EwECOAIF_External_Interface.h"

struct timespec Zzzz = { 0, 10000000 };

void* buttonPoller( void* p )
{
	int key;
	//
	// Poll the buttons - well, alright, the keyboard...
	for(;;){
		key = getch();
		switch( key ){
			case 'A': case 'a':
				EwECOAIF__ButtonA();
				break;
			case 'B': case 'b':
				EwECOAIF__ButtonB();
				break;
			case 'C': case 'c':
				EwECOAIF__ButtonC();
				break;
			case 'D': case 'd':
				EwECOAIF__ButtonD();
				break;
			default:
				break;
		}
		nanosleep( &Zzzz, NULL );
	}
	return NULL;
}

void ioinit()
{
	static pthread_t keythrd;
	//
	initscr(); cbreak(); noecho();
	nodelay( stdscr, !0 );
	//
	// Spin the button (keyboard) poller
	pthread_create( &keythrd, NULL, buttonPoller, NULL );
}

void putLights( unsigned char x )
{
	unsigned char i;
	unsigned char xc = x;
	char res[9];
	//
	for( i = 0; i < 8; i++ ){
		if( xc & 0x80 )
			res[i] = 'o';
		else
			res[i] = '.';
		xc = xc << 1;
	}
	res[i] = '\000';
	//
	mvwprintw( stdscr, 0, 0, "Display: %s\n\n", res );
	redrawwin( stdscr );
}
