/*
 * EwECOAIF_Host.c
 *
 *  Created on: 12 Oct 2016
 *      Author: sw_appleby
 */

#include <stdio.h>
#include <pthread.h>
#include <time.h>
#include <wiringPi.h>

#include "../EwECOAIF_External_Interface.h"

struct timespec Zzzz = { 0, 10000000 };

void* buttonPoller( void* p )
{
	// Poll the buttons...
	for(;;){
		if( digitalRead(0) ){
			EwECOAIF__ButtonA();
		}
		else if( digitalRead(2) ){
			EwECOAIF__ButtonB();
		}
		else if( digitalRead(4) ){
			EwECOAIF__ButtonC();
		}
		else if( digitalRead(5) ){
			EwECOAIF__ButtonD();
		}
		nanosleep( &Zzzz, NULL );
	}
	return NULL;
}

void ioinit()
{
	static pthread_t keythrd;
	unsigned char i;
	//
	// Setup the wiringPi library
	wiringPiSetup();
	//
	// Setup the GPIOs we want as inputs...
	pinMode( 0, INPUT );
	pinMode( 2, INPUT );
	pinMode( 4, INPUT );
	pinMode( 5, INPUT );
	//
	// Setup the GPIOs we want as outputs
	for( i = 23 ; i < 29 ; ++i )
		pinMode( i, OUTPUT );
	//
	// Spin the button poller
	pthread_create( &keythrd, NULL, buttonPoller, NULL );
}

char *toText( unsigned char x )
{
	unsigned char i;
	unsigned char xc = x;
	static char res[9];
	//
	for( i = 0; i < 8; i++ ){
		if( xc & 0x80 )
			res[i] = 'o';
		else
			res[i] = '.';
		xc = xc << 1;
	}
	res[i] = '\000';
	return res;
}

void putLights( unsigned char displayCode )
{
	digitalWrite( 28, ( displayCode & 0x01 ? 1 : 0 ));
	digitalWrite( 27, ( displayCode & 0x02 ? 1 : 0 ));
	digitalWrite( 26, ( displayCode & 0x04 ? 1 : 0 ));
	digitalWrite( 25, ( displayCode & 0x08 ? 1 : 0 ));
	digitalWrite( 24, ( displayCode & 0x10 ? 1 : 0 ));
	digitalWrite( 23, ( displayCode & 0x20 ? 1 : 0 ));
	//
	printf( "%s                     \r", toText( displayCode )); fflush( stdout );
}
