/* @file EwECOA_modMain_Im_container.c
 * Container Interface for Module EwECOA_modMain_Im
 */
/*
 ##############################################################
 # (C) 2016 BAE SYSTEMS
 #
 # EmbedWithECOA - Bare minimum EwECOA Container implementation
 #
 # $Id: EwECOA_modMain_Im_container.c,v 2.2 2017/11/06 15:33:43 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes, 
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/

#include "EwECOA_platform.h"
#include "EwECOA_modMain_Im_container.h"

/* Logging and fault management services API */
void EwECOA_modMain_Im_container__log_trace
   (EwECOA_modMain_Im__context* context, const ECOA__log log)
{
//	EwECOA_platform_log( log->data, log->current_size, Trace );// struct args converted to pointer-to-struct
}

void EwECOA_modMain_Im_container__log_debug
   (EwECOA_modMain_Im__context* context, const ECOA__log log)
{
//	EwECOA_platform_log( log->data, log->current_size, Debug );
}

void EwECOA_modMain_Im_container__log_info
   (EwECOA_modMain_Im__context* context, const ECOA__log log)
{
//	EwECOA_platform_log( log->data, log->current_size, Info );
}

void EwECOA_modMain_Im_container__log_warning
   (EwECOA_modMain_Im__context* context, const ECOA__log log)
{
//	EwECOA_platform_log( log->data, log->current_size, Warning );
}

void EwECOA_modMain_Im_container__raise_error
   (EwECOA_modMain_Im__context* context, const ECOA__log log)
{
//	EwECOA_platform_log( log->data, log->current_size, Error );
}

void EwECOA_modMain_Im_container__raise_fatal_error
   (EwECOA_modMain_Im__context* context, const ECOA__log log)
{
//	EwECOA_platform_log( log->data, log->current_size, Error );
//	for(;;); // die
}

/* Time services API */
void EwECOA_modMain_Im_container__get_relative_local_time
   (EwECOA_modMain_Im__context* context, ECOA__hr_time* relative_local_time)
{
	hrClock( relative_local_time );
}

ECOA__return_status EwECOA_modMain_Im_container__get_UTC_time
   (EwECOA_modMain_Im__context* context, ECOA__global_time* utc_time)
{
//	utc_time->seconds = utc_time->nanoseconds = 0;
	return ECOA__return_status_OPERATION_NOT_AVAILABLE;
}

ECOA__return_status EwECOA_modMain_Im_container__get_absolute_system_time
   (EwECOA_modMain_Im__context* context, ECOA__global_time* absolute_system_time)
{
//	gblClock( absolute_system_time );
	return ECOA__return_status_OK;
}

/* Time resolution services API */
void EwECOA_modMain_Im_container__get_relative_local_time_resolution
   (EwECOA_modMain_Im__context* context, ECOA__duration* relative_local_time_resolution)
{
//	relative_local_time_resolution->nanoseconds = ClockResolution.nanoseconds;
//	relative_local_time_resolution->seconds = ClockResolution.seconds;
}

void EwECOA_modMain_Im_container__get_UTC_time_resolution
   (EwECOA_modMain_Im__context* context, ECOA__duration* utc_time_resolution)
{
//	utc_time_resolution->seconds = 1;
//	utc_time_resolution->nanoseconds = 0;
}

void EwECOA_modMain_Im_container__get_absolute_system_time_resolution
   (EwECOA_modMain_Im__context* context, ECOA__duration* absolute_system_time_resolution)
{
//	absolute_system_time_resolution->nanoseconds = ClockResolution.nanoseconds;
//	absolute_system_time_resolution->seconds = ClockResolution.seconds;
}

void EwECOA_modMain_Im_container__DisplayCode__send
   (EwECOA_modMain_Im__context* context,
    const ECOA__uint8 code)
{
	EwECOA_platform_DisplayCode_send( code );
}
