/*
 * EwECOA_platform.h
 *
 *  Created on: 28 Sep 2016
 *      Author: SW_APPLEBY
 */
/*
 ##############################################################
 # (C) 2016 BAE SYSTEMS
 #
 # EmbedWithECOA - Bare minimum ECOA S/W Platform definitions
 #
 # $Id: EwECOA_platform.h,v 2.4 2017/11/06 15:33:43 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes, 
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/

#ifndef STEPS_BAREBOARD_SRC_EWECOA_PLATFORM_H_
#define STEPS_BAREBOARD_SRC_EWECOA_PLATFORM_H_

#include <ECOA.h>
#if defined( PIC )
#include "bspPIC.h"
#endif

#include <EwECOA_modMain_Im_container.h>
#include <EwECOAIF_modMain_Im_container.h>

/* ECOA:module_states_type */
typedef ECOA__uint32 ECOA_Platform__module_states_type;
#define ECOA_Platform__module_states_type_IDLE    (0)
#define ECOA_Platform__module_states_type_READY   (1)
#define ECOA_Platform__module_states_type_RUNNING (2)

typedef struct {
	ECOA_Platform__module_states_type moduleState;
	ECOA_Platform__module_states_type tickerState;
} EwECOA_modMain_Im_PlatformContext;

typedef struct {
	ECOA_Platform__module_states_type moduleState;
} EwECOAIF_modMain_Im_PlatformContext;

typedef enum  { Info, Trace, Debug, Warning, Error } LogLevel;

extern ECOA__duration ClockResolution;

int EwECOA_platform__main();

void EwECOA_platform_log( char *msg, int msgLen, LogLevel level );

void hrClock( ECOA__hr_time *hr_time );
void gblClock( ECOA__global_time *gbl_time );

//######################################################################################

void EwECOA_platform_DisplayCode_send( const ECOA__uint8 code );

//######################################################################################

void EwECOA_platform_PatternASelected_send();
void EwECOA_platform_PatternBSelected_send();
void EwECOA_platform_PatternCSelected_send();
void EwECOA_platform_PatternDSelected_send();

#endif /* STEPS_BAREBOARD_SRC_EWECOA_PLATFORM_H_ */
