/*
 * bspPIC.h
 *
 *  Created on: 30 Sep 2016
 *      Author: SW_APPLEBY
 */
/*
 ##############################################################
 # (C) 2016 BAE SYSTEMS
 #
 # EmbedWithECOA - "BSP" function definitions for the PIC
 #
 # $Id: bspPIC.h,v 2.1 2017/11/06 15:33:43 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes, 
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/

#ifndef STEPS_BAREBOARD_SRC_BSPPIC_H_
#define STEPS_BAREBOARD_SRC_BSPPIC_H_

#if   PIC==0x16f627
#  include <pic16f627.h>
#  define LEDPORT PORTB
#  define BTNPORT PORTA
//
#elif PIC==0x16f873
#  include <pic16f873.h>
#  define LEDPORT PORTA
#  define BTNPORT PORTB
	//
#elif PIC==0x16f876
#  include <pic16f876.h>
#  define LEDPORT PORTA
#  define BTNPORT PORTB
	//
#elif PIC==0x16f876a
#  include <pic16f876a.h>
#  define LEDPORT PORTA
#  define BTNPORT PORTB
#else
#  error Must define variable 'PIC'
#endif

	// Simple funcs.
# define setBit(s,b) ((s) |= (1<<(b)))
# define clrBit(s,b) ((s) &=~(1<<(b)))
	//
# define WritePort(p,v) ((p) = (v))
# define ReadPort(p,v)  ((v) = (p))
	//
# define LSWORD(x)  ((x) & 0x0000FFFF)
# define MSWORD(x) (((x) & 0xFFFF0000)>>8)
	//
# define byte unsigned char
typedef long clock_t;
	//
# define CLOCKS_PER_SEC 10000L
	//
void     pfinit();
clock_t  clock();
unsigned sleep( unsigned secs );
unsigned usleep( unsigned usecs );

#endif /* STEPS_BAREBOARD_SRC_BSPPIC_H_ */
